# -*- coding: utf-8 -*-
#
# diese Datei: datenstrukturen.py
#
# letzte Änderung/en
# Di 15. Mär 18:13:16 CET 2011
#
# Diese Datei wird die [Python-]Klassen zur Arbeit mit  
# den Datenstrukturen enthalten, die lt. Vorgaben zum 
# Zentralabitur im Informatikunterricht der gymnasialen 
# Oberstufe in der Qualifikationsphase im Unterricht 
# thematisiert werden.
#
# Zur Zeit enthält sie die Klasse Liste
#
# Zur Nutzung ist die Zeile
# from datenstrukturen import Liste [, ...] 
# in das Programm aufzunehmen, das die Klasse Liste 
# verwendet. 
#
class Liste:
	def __init__(self):
		self.__list = list() # <type 'list'>

	def fuegeEinAnPosition(self, position, element):
		self.__list.insert(position, element)

	def gibElementAnPosition(self, position):
		return self.__list[position]

	def haengeAn(self, element):
		self.__list.append(element)

	def entferne(self, element):
		self.__list.remove(element)

	def entferneAnPosition(self, position):
		if position >= len(self.__list):
			print "Fehler: Es existiert kein",
			print str(position) + ". Element in dieser Liste."
		else:
			self.__list[position:position+1] = []

	def istEnthalten(self, element):
		return element in self.__list

	def gibLaenge(self):
		return len(self.__list)

	def istLeer(self):
		return len(self.__list) == 0

	def fuerAlleDurchfuehren(self, aktion):
		for elem in self.__list:
			ak=aktion + " (elem)"			
			exec(ak) 

	def anzeigen(self):
		print self.__list

	def __repr__(self):
		return repr(self.__list)

# [Selbst-]Test der Funktionalitäten
if __name__ == "__main__":
	# Klasse Liste:
	testListe = Liste()
	testListe.anzeigen()
	testListe.haengeAn("Dies")
	testListe.anzeigen()
	testListe.haengeAn("ist")
	testListe.anzeigen()
	testListe.haengeAn("ein")
	testListe.anzeigen()
	testListe.haengeAn("Test")
	testListe.anzeigen()
	testListe.entferneAnPosition(1)
	testListe.anzeigen()
	testListe.entferneAnPosition(9)
	testListe.anzeigen()
	if testListe.istEnthalten("Test"):
		testListe.entferne("Test")
		testListe.anzeigen()
	testListe.fuerAlleDurchfuehren("print len")
	
