/* Dieses Programm ist in Zusammenarbeit Referendare und ehemaligen Referendaren der Informatik 
* Studienseminare Hamm und Ansberg entstanden. Es steht unter der Creative Commons 
* by-nc-sa-Lizenz in der Version 3.0 ( http://creativecommons.org/licenses/by-nc-sa/3.0/de/ ).
* Folglich darf es beliebig kopiert und bearbeitet werden, sofern das Folgeprodukt wiederum unter 
* gleichen Lizenzbedingungen vertrieben und auf die ursprnglichen Urheber verwiesen wird. 
*
* Die Namensnennung der ursprnglichen Urheber auf Arbeitsblttern und Programmbeispielen fr 
* die Schlerinnen und Schler ist nicht erforderlich, wohl aber bei der Weitergabe der 
* Materialien (beispielsweise zu Unterrichts- oder Forschungszwecken).
*
* Weitere Lizenz: GPL V3.0
* Siehe http://www.gnu.org/licenses/gpl-3.0.html
*/

public class Spieler {
	// Bezugsobjekte
	private Spieler kenntVorgaenger;
	private Spieler kenntNachfolger;
	private Wuerfelbecher kenntBecher;
	
	// Attribute
	private int vorgaengerzahl;
	private int eigeneZahl;
	private int strafpunkte; // Neu - optional
	private String name; // Neu
	
	// Konstruktor
	public Spieler(String pName) {// Neu
		name = pName;
		strafpunkte = 0; // - optional
	}

	// Dienste/Methoden
	public void merkeVorgaengerzahl(int pZahl) {
		vorgaengerzahl = pZahl;
	}
	
	public void leseGewuerfelteZahl() {
		eigeneZahl = kenntBecher.zeigeWuerfelergebnis();
	}
	
	public int nenneEigeneZahl() {
		return eigeneZahl;
	}
	
	public String gibName() { // Neu
		return name;
	}
	
	public int gibStrafpunkte() { // Neu - optional
		return strafpunkte;
	}
	
	public int gibVorgaengerzahl() {
		return vorgaengerzahl;
	}
	
	public void nimmWuerfelbecher(Wuerfelbecher pBecher) {
		kenntBecher = pBecher;
	}
	
	public void gibWuerfelbecherAb() { // Neu
		kenntBecher = null;
	}
	
	public void schuettleBecher() {
		kenntBecher.schuettelDich();
	}
	
	public void setzeVorgaenger(Spieler pVorgaenger) {
		kenntVorgaenger = pVorgaenger;
	}
	
	public void setzeNachfolger(Spieler pNachfolger) {
		kenntNachfolger = pNachfolger;
	}
	
	public void setzeStrafpunkt() { // Neu - optional
		strafpunkte = strafpunkte + 1;
	}
	
	public void starteSpielrunde() { // Neu
		// Der aktive Spieler schttelt den Becher, merkt sich die Zahl und gibt ihn an den Nachfolger weiter
		System.out.println("--- Neue Spielrunde ---");
		System.out.println("Es beginnt " + name);
		this.schuettleBecher();
		System.out.println(name + " wrfelt " + kenntBecher.zeigeWuerfelergebnis());
		this.leseGewuerfelteZahl();
		kenntNachfolger.nimmWuerfelbecher(kenntBecher);
		this.gibWuerfelbecherAb();
		kenntNachfolger.fuehreZugAus();
	}
	
	public void fuehreZugAus() { // Neu
		System.out.println(name + " ist am Zug");
		this.merkeVorgaengerzahl(kenntVorgaenger.nenneEigeneZahl());
		System.out.println(name + " erhlt vom Vorgnger " + vorgaengerzahl + " genannt");
		
		// Eine Einscheidung steht an:
		//1.) Weitergeben und nchsthhere Zahl ansagen
		//2.) Aufdecken, 
		//3.) Neu wrfeln, Ergebnis anschauen, weitergeben und eine hhere Zahl ansagen als die zuvor genannte
		
		if(this.gibWertigkeitZu(vorgaengerzahl) < 8) { // 3.) Neu wrfeln, Ergebnis anschauen, weitergeben und eine hhere Zahl ansagen als die zuvor genannte
			System.out.println(name + " entscheidet sich neu zu wrfeln");
			this.schuettleBecher();
			System.out.println(name + " wrfelt " + kenntBecher.zeigeWuerfelergebnis());
			this.leseGewuerfelteZahl();
			if(this.gibWertigkeitZu(eigeneZahl) < this.gibWertigkeitZu(vorgaengerzahl)) { // Der aktive Spieler muss lgen:
				eigeneZahl = this.gibErgebnisZu(this.gibWertigkeitZu(vorgaengerzahl) + 1); // eigeneZahl weicht nun vom Ergebnis unter dem Wrfelbecher ab, ist also erlogen.
			}
			kenntNachfolger.nimmWuerfelbecher(kenntBecher);
			this.gibWuerfelbecherAb();
			kenntNachfolger.fuehreZugAus();
		}	else if(this.gibWertigkeitZu(vorgaengerzahl) < 15) { // 1.) Weitergeben und nchsthhere Zahl ansagen
			System.out.println(name + " entscheidet sich den Becher weiter zu geben");        
			eigeneZahl = this.gibErgebnisZu(this.gibWertigkeitZu(vorgaengerzahl) + 1);
			kenntNachfolger.nimmWuerfelbecher(kenntBecher);
			this.gibWuerfelbecherAb();
			kenntNachfolger.fuehreZugAus();
		}	else { // 2.) Aufdecken
			System.out.println(name + " entscheidet sich den Becher aufzudecken");
			System.out.println("Unter dem Becher befindet sich " + kenntBecher.zeigeWuerfelergebnis());
			if(this.gibWertigkeitZu(vorgaengerzahl) <= this.gibWertigkeitZu(kenntBecher.zeigeWuerfelergebnis())) { // Ansage vom Vorgnger stimmt, aktiver Spieler hat verloren
				this.setzeStrafpunkt(); // - optional
				if(kenntBecher.zeigeWuerfelergebnis() == 21) { // Zustzlicher Strafpunkt wegen Meier - optional
					this.setzeStrafpunkt();   
				}
				System.out.println(name + " verliert und erhlt einen Strafpunkt. Gesamtanzahl Strafpunkte: " + strafpunkte);
				/*if(strafpunkte < 3) { // Abbruchbedingung
					this.starteSpielrunde();
				}*/
			} else {// Ansage vom Vorgnger ist hher als das tatschliche Ergebnis, der Vorgnger hat verloren
				kenntVorgaenger.setzeStrafpunkt(); // - optional
				if(kenntBecher.zeigeWuerfelergebnis() == 21) { // Zustzlicher Strafpunkt wegen Meier - optional
					kenntVorgaenger.setzeStrafpunkt(); 
				}
				System.out.println(kenntVorgaenger.gibName() + " verliert und erhlt einen Strafpunkt. Gesamtanzahl Strafpunkte: " + kenntVorgaenger.gibStrafpunkte());           
				/*if(kenntVorgaenger.gibStrafpunkte() < 3) { // Abbruchbedingung
					kenntVorgaenger.nimmWuerfelbecher(kenntBecher);
					kenntVorgaenger.starteSpielrunde();
				}*/
			}
		}
	}
	
	public int gibWertigkeitZu(int pErgebnis) {
		// Ordnet einem Wrfelergebnis die Wertigkeit im Spiel Meiern zu: 
		// 31 ist der niedrigste Wert, 21 (Meier) der hchste.
		switch(pErgebnis) {
			case 31: return 1;
			case 32: return 2;
			case 41: return 3;
			case 42: return 4;
			case 43: return 5;
			case 51: return 6;
			case 52: return 7;
			case 53: return 8;
			case 54: return 9;
			case 61: return 10;
			case 62: return 11;
			case 63: return 12;
			case 64: return 13;
			case 65: return 14;
			case 11: return 15;
			case 22: return 16;
			case 33: return 17;
			case 44: return 18;
			case 55: return 19;
			case 66: return 20;
			case 21: return 21;
			
			default: return 0;
		}
	}
	
	public int gibErgebnisZu(int pWertigkeit) {
		// Ordnet einer Wertigkeit im Spiel Meiern das entsprechende Wrfelergebnis zu: 
		// Das Ergebnis mit der niedrigsten Wertigkeit (1) ist 31, das mit der hchsten (21) ist 21 (Meier)
		switch(pWertigkeit) {
			case 1: return 31;
			case 2: return 32;
			case 3: return 41;
			case 4: return 42;
			case 5: return 43;
			case 6: return 51;
			case 7: return 52;
			case 8: return 53;
			case 9: return 54;
			case 10: return 61;
			case 11: return 62;
			case 12: return 63;
			case 13: return 64;
			case 14: return 65;
			case 15: return 11;
			case 16: return 22;
			case 17: return 33;
			case 18: return 44;
			case 19: return 55;
			case 20: return 66;
			case 21: return 21;
			
			default: return 0;
		}
	}
}