#!/usr/bin/python
# -*- coding: iso-8859-15 -*-
#
# Dieses Programm ist in Zusammenarbeit Referendare und ehemaligen Referendaren der Informatik 
# Studienseminare Hamm und Ansberg entstanden. Es steht unter der Creative Commons 
# by-nc-sa-Lizenz in der Version 3.0 ( http://creativecommons.org/licenses/by-nc-sa/3.0/de/ ).
# Folglich darf es beliebig kopiert und bearbeitet werden, sofern das Folgeprodukt wiederum unter 
# gleichen Lizenzbedingungen vertrieben und auf die ursprnglichen Urheber verwiesen wird. 
#
# Die Namensnennung der ursprnglichen Urheber auf Arbeitsblttern und Programmbeispielen fr 
# die Schlerinnen und Schler ist nicht erforderlich, wohl aber bei der Weitergabe der 
# Materialien (beispielsweise zu Unterrichts- oder Forschungszwecken).



# Anederungsdienst:
# 
# statt self.stuecke=[] wurde die OO-Schreibweise 
# self.stuecke=list() gewaehlt
# einziger Wermutstropfen:
# list wird in Python kleingeschrieben

# Kontrolle/Test:
# Auftrag 
# gibLieblingsliederAus
class Hoerer:
    def __init__(self,derName):
        self.name=derName
        self.stuecke=list()
        print "Objekt der Klasse Hoerer erstellt: ",derName

    def fuegeStueckHinzu(self,stueck):
        self.stuecke.append(stueck)

    def entferneStueck(self,stueck):
        if stueck in self.stuecke:
            self.stuecke.remove(stueck)

    def gibLieblingslieder(self):
        return self.stuecke

    def gibLieblingsliederAus(self):
        print self.name,[(lied.gibKuenstlerin(),lied.gibName()) for lied in self.gibLieblingslieder()]



class Musikstueck:
    def __init__(self,derName,dieKuenstlerIn):
        self.name=derName
        self.kuenstlerin=dieKuenstlerIn
        print "Objekt der Klasse Musikstueck erstellt:",derName,"-- Gruppe:",dieKuenstlerIn

    def gibKuenstlerin(self):
        return self.kuenstlerin

    def gibName(self):
        return self.name


class Gruppe:
    def __init__(self,derName):
        self.name=derName
        self.hoerer=list()
        print "Objekt der Klasse Gruppe erstellt:", derName

    def fuegeHoererHinzu(self,neuerHoerer):
        self.hoerer.append(neuerHoerer)

    def entferneHoerer(self,hoerer):
        if hoerer in self.hoerer:
            self.hoerer.remove(hoerer)

    def erstellePlaylist(self):
        print "erstellePlaylist"
        self.playlist=Playlist() # Aggregation (Objekt der Klasse Gruppe _hat_ ...)

    def erstelleGemeinsameLieblingslieder(self,liste1,liste2):
        # kuerzere der beiden Listen nehmen
        self.erstellePlaylist()
        anzahl=min(liste1.__len__(),liste2.__len__())
        if anzahl==liste2.__len__():
            liste1,liste2=liste2,liste1
        for zaehl in range(0,anzahl):
            if liste1[zaehl] in liste2:
                self.playlist.fuegeStueckHinzug(liste1[zaehl])
                print liste1[zaehl].gibKuenstlerin(),liste1[zaehl].gibName(), "angefuegt"
        return self.playlist.gibAbspielliste()

class Playlist:
    def __init__(self):
        self.liste=list()
        print "Objekt der Klasse Playlist erstellt"

    def fuegeStueckHinzug(self,stueck):
        self.liste.append(stueck)

    def entferneStueck(self,stueck):
        if stueck in self.liste:
            self.liste.remove(stueck)

    def abspielen(self):
        print "Abspielen der Stuecke des Objekts der Playlist:", self.liste
        print [(lied.gibKuenstlerin(),lied.gibName()) for lied in self.liste]

    def gibAbspielliste(self):
        return self.liste


#>>> from musikzentrum import Hoerer, Musikstueck, Gruppe, Playlist
#>>> dir()
#['Gruppe', 'Hoerer', 'Musikstueck', 'Playlist', '__builtins__', '__doc__', '__file__', '__name__', 'help', 'readline', 'rlcompleter', 'stuecke']

# Erzeugen aller Objekte:
#
gruppeSpieleabend=Gruppe("Gruppe Spieleabend")

david=Hoerer("David")
klaus=Hoerer("Klaus")
lisa=Hoerer("Lisa")

gutenTag=Musikstueck("Guten Tag","Wir sind Helden")
losingMyReligion=Musikstueck("Losing my Religion","REM")
parallelUniverse=Musikstueck("Parallel Universum","Red Hot Chilli Pepper")
radioBrennt=Musikstueck("Radio brennt","Die rzte")
bonnieUndClyde=Musikstueck("Bonnie und Clyde","Die toten Hosen")

# Objektebeziehungen aufbauen
# hoert gerne:
david.fuegeStueckHinzu(gutenTag)
david.fuegeStueckHinzu(losingMyReligion)
david.fuegeStueckHinzu(radioBrennt)
david.fuegeStueckHinzu(bonnieUndClyde)

klaus.fuegeStueckHinzu(losingMyReligion)
klaus.fuegeStueckHinzu(parallelUniverse)
klaus.fuegeStueckHinzu(radioBrennt)
klaus.fuegeStueckHinzu(bonnieUndClyde)

lisa.fuegeStueckHinzu(gutenTag)
lisa.fuegeStueckHinzu(parallelUniverse)
lisa.fuegeStueckHinzu(radioBrennt)
lisa.fuegeStueckHinzu(bonnieUndClyde)

#Test
david.gibLieblingsliederAus()
klaus.gibLieblingsliederAus()
lisa.gibLieblingsliederAus()

# Objektebeziehungen
# setzt sich zusammen aus: 
gruppeSpieleabend.fuegeHoererHinzu(david)
gruppeSpieleabend.fuegeHoererHinzu(klaus)
gruppeSpieleabend.fuegeHoererHinzu(lisa)


gruppeSpieleabend.erstelleGemeinsameLieblingslieder(gruppeSpieleabend.erstelleGemeinsameLieblingslieder(david.gibLieblingslieder(),klaus.gibLieblingslieder()),lisa.gibLieblingslieder())

gruppeSpieleabend.playlist.abspielen()