#!/usr/bin/python
# -*- coding: iso-8859-15 -*-
#
# Dieses Programm ist in Zusammenarbeit Referendare und ehemaligen Referendaren der Informatik 
# Studienseminare Hamm und Ansberg entstanden. Es steht unter der Creative Commons 
# by-nc-sa-Lizenz in der Version 3.0 ( http://creativecommons.org/licenses/by-nc-sa/3.0/de/ ).
# Folglich darf es beliebig kopiert und bearbeitet werden, sofern das Folgeprodukt wiederum unter 
# gleichen Lizenzbedingungen vertrieben und auf die ursprnglichen Urheber verwiesen wird. 
#
# Die Namensnennung der ursprnglichen Urheber auf Arbeitsblttern und Programmbeispielen fr 
# die Schlerinnen und Schler ist nicht erforderlich, wohl aber bei der Weitergabe der 
# Materialien (beispielsweise zu Unterrichts- oder Forschungszwecken).

# Umsetzung in Python - bisher ohne Klassenbeziehungen

from sets import Set 

# Kontrolle/Test:
# Auftrag 
# gibLieblingsliederAus
class Hoerer:
    def __init__(self,derName):
        self.name=derName
        self.stuecke=Set()
        print "Objekt der Klasse Hoerer erstellt: ",derName

    def fuegeStueckHinzu(self,stueck):
        self.stuecke.add(stueck)

    def entferneStueck(self,stueck):
        if stueck in self.stuecke:
            self.stuecke.remove(stueck)

    def gibLieblingslieder(self):
        return self.stuecke
        
    def gibLieblingsliederAus(self):
        print self.name,[(lied.gibKuenstlerin(),lied.gibName()) for lied in self.gibLieblingslieder()]
        


class Musikstueck:
    def __init__(self,derName,dieKuenstlerIn):
        self.name=derName
        self.kuenstlerin=dieKuenstlerIn        
        print "Objekt der Klasse Musikstueck erstellt:",derName,"-- Gruppe:",dieKuenstlerIn

    def gibKuenstlerin(self):
        return self.kuenstlerin

    def gibName(self):
        return self.name            


class Gruppe:
    def __init__(self,derName):
        self.name=derName
        self.hoerer=Set()
        print "Objekt der Klasse Gruppe erstellt:", derName
    
    def fuegeHoererHinzu(self,neuerHoerer):
        self.hoerer.add(neuerHoerer)

    def entferneHoerer(self,hoerer):
        if hoerer in self.hoerer:
            self.hoerer.remove(hoerer)
            
    def erstellePlaylist(self):
        print "erstellePlaylist"
        self.playlist=Playlist() # Aggregation (Objekt der Klasse Gruppe _hat_ ...)
        
    def erstelleGemeinsameLieblingslieder(self,menge1,menge2):
        self.erstellePlaylist()
        #
        # Mengenschnitt bilden
        self.playlist.setzeMenge(menge1.intersection(menge2))    
        return self.playlist.gibAbspielmenge()
        

class Playlist:
    def __init__(self):
        self.menge=Set()
        print "Objekt der Klasse Playlist erstellt"

    def fuegeStueckHinzug(self,stueck):
        self.menge.add(stueck)

    def entferneStueck(self,stueck):    
        if stueck in self.menge:
            self.menge.remove(stueck)

    def setzeMenge(self, neueMenge):
        self.menge=neueMenge
    
    def abspielen(self):
        print "Abspielen der Stuecke des Objekts der Playlist:", self.menge
        print [(lied.gibKuenstlerin(),lied.gibName()) for lied in self.menge]
        
    def gibAbspielmenge(self):
        return self.menge   


#>>> from musikzentrum import Hoerer, Musikstueck, Gruppe, Playlist
#>>> dir()
#['Gruppe', 'Hoerer', 'Musikstueck', 'Playlist', '__builtins__', '__doc__', '__file__', '__name__', 'help', 'readline', 'rlcompleter', 'stuecke']

# Erzeugen der Objekte:
#
gruppeSpieleabend=Gruppe("Gruppe Spieleabend")

david=Hoerer("David")
klaus=Hoerer("Klaus")
lisa=Hoerer("Lisa")

gutenTag=Musikstueck("Guten Tag","Wir sind Helden")
losingMyReligion=Musikstueck("Losing my Religion","REM")
parallelUniverse=Musikstueck("Parallel Universum","Red Hot Chili Peppers")
radioBrennt=Musikstueck("Radio brennt","Die rzte")
bonnieUndClyde=Musikstueck("Bonnie und Clyde","Die toten Hosen")

# Objektebeziehungen aufbauen
# hoert gerne:
david.fuegeStueckHinzu(gutenTag)
david.fuegeStueckHinzu(losingMyReligion)
david.fuegeStueckHinzu(radioBrennt)
david.fuegeStueckHinzu(bonnieUndClyde)

klaus.fuegeStueckHinzu(losingMyReligion)
klaus.fuegeStueckHinzu(parallelUniverse)
klaus.fuegeStueckHinzu(radioBrennt)
klaus.fuegeStueckHinzu(bonnieUndClyde)

lisa.fuegeStueckHinzu(gutenTag)
lisa.fuegeStueckHinzu(parallelUniverse)
lisa.fuegeStueckHinzu(radioBrennt)
lisa.fuegeStueckHinzu(bonnieUndClyde)

#Test
david.gibLieblingsliederAus()
klaus.gibLieblingsliederAus()
lisa.gibLieblingsliederAus()

# Objektebeziehungen
# setzt sich zusammen aus: 
gruppeSpieleabend.fuegeHoererHinzu(david)
gruppeSpieleabend.fuegeHoererHinzu(klaus)
gruppeSpieleabend.fuegeHoererHinzu(lisa)

# Gemeinsame Menge aller drei erstellen
gruppeSpieleabend.erstelleGemeinsameLieblingslieder(gruppeSpieleabend.erstelleGemeinsameLieblingslieder(david.gibLieblingslieder(),klaus.gibLieblingslieder()),lisa.gibLieblingslieder())

# Menge abspielen
gruppeSpieleabend.playlist.abspielen()
