#!/usr/bin/python
# -*- coding: iso-8859-15 -*-
#
# Dieses Programm ist in Zusammenarbeit Referendare und ehemaligen Referendaren der Informatik 
# Studienseminare Hamm und Ansberg entstanden. Es steht unter der Creative Commons 
# by-nc-sa-Lizenz in der Version 3.0 ( http://creativecommons.org/licenses/by-nc-sa/3.0/de/ ).
# Folglich darf es beliebig kopiert und bearbeitet werden, sofern das Folgeprodukt wiederum unter 
# gleichen Lizenzbedingungen vertrieben und auf die ursprnglichen Urheber verwiesen wird. 
#
# Die Namensnennung der ursprnglichen Urheber auf Arbeitsblttern und Programmbeispielen fr 
# die Schlerinnen und Schler ist nicht erforderlich, wohl aber bei der Weitergabe der 
# Materialien (beispielsweise zu Unterrichts- oder Forschungszwecken).

##################################################################################
# -*- coding: latin-1 -*-
# Musterloesung: Music-Center Jhg 11.
# Version 1
# Einschraenkungen:
# -----------------
# - Erstellung von (Musik)Playlisten fuer Gruppen von Personen
# - Kriterium: Playlisten enthalten die Stuecke die alle Personen gerne hoehren 
# - es gibt nur eine Gruppe mit genau einer Playliste
# - Methode abspielen() soll Playliste im einfachen M3U-Format in das
#   aktuelle Arbeitsverzeichnis speichern, kann von vielen Mediaplayern abgespielt werden.
# Moegliche Erweiterungen bzw Nachfolgeversionen:
# -----------------------------------------------
# - verschiedenen/mehrere Kriterien zur Erstellung der Playlisten
# - mehrere Gruppen mit mehreren Playlisten zulassen
##################################################################################


class Person(object):
    def __init__(self,nameNeu):
        print 'Objekt der Klasse Person erstellt'
        self.name = nameNeu         # name wird bei Objekterstellung mitgegeben
        self.lieblingsStuecke = []  # Liste lieblingsStuecke ist zunaechst leer
        
    def stueckEntfernen(self,stueck):
        self.lieblingsStuecke.remove(stueck)

    def stueckHinzu(self,stueck):
        self.lieblingsStuecke.append(stueck)

    def gibLieblingsStuecke(self):
        return self.lieblingsStuecke

    def gibName(self):              # nur zum Testen
        return self.name


class Stueck(object):
    def __init__(self,interpretNeu,titelNeu,dateiNeu):
        print 'Objekt der Klasse Stueck erstellt'
        self.interpret = interpretNeu     # interpret wird bei Objekterstellung mitgegeben
        self.titel = titelNeu             # titel wird bei Objekterstellung mitgegeben
        self.datei = dateiNeu             # datei wird bei Objekterstellung mitgegeben

    def abspielen(self,datei):        
        print 'spiele: ' + self.interpret + ':' + self.titel
        datei.write(self.datei)           # Dateiname in datei für Playlisten schreiben
        datei.write('\n')
            

class Playliste(object):
    def __init__(self):
        print 'Objekt der Klasse Playliste erstellt'
        self.stuecke = []                # Liste stuecke ist zunaechst leer
        self.dateiname = 'playliste.m3u'
                                         
    def stueckEntfernen(self,stueck):
        self.stuecke.remove(stueck)

    def stueckHinzu(self,stueck):
        self.stuecke.append(stueck)

    def abspielen(self):
        print 'abspielen der Playliste'
        datei = file(self.dateiname,'w')
        for s in self.stuecke:
            s.abspielen(datei)
        datei.close()
        print 'Ende der Playliste'
            
    def setzteStuecke(self,listeNeu):
        self.stuecke = listeNeu
        

class Gruppe(object):
    def __init__(self):
        print 'Objekt der Klasse Gruppe erstellt'
        self.personen = []               # Liste personen ist zunaechst leer
        self.playliste = Playliste()     # Die Gruppe hat die Playliste

    def gibPersonen(self):
        return self.personen

    def personEntfernen(self,person):
        self.personen.remove(person)

    def personHinzu(self,person):
        self.personen.append(person)

    def abspielen(self):
        self.playliste.abspielen()

    def erstellePlayliste(self):
        print('erstellePlayliste')
        liste = []                       # wie erklaert man liste? Oder besser liste als Hilfsattribut?
        liste = self.gleicheStuecke(self.personen)
        # Erweiterung der Erzeugungskriterien koennte wie folgt aussehen:
        # if liste==[]: 
        #     liste = self.Zufall(self.personen)
        # if liste==[]: 
        #     liste = self.Gemischt(self.personen)
        # ...
        self.playliste.setzteStuecke(liste)

    def gleicheStuecke(self, personen):
        if personen == []:
            print 'keine Personen in Gruppe'
            return []
        else:
            schnitt = personen[0].gibLieblingsStuecke()
            for p in personen:
                schnitt = self.findeGleiche(schnitt,p.gibLieblingsStuecke())
            return schnitt

    def findeGleiche(self,liste1,liste2):
        gleiche = []                     # Liste gleiche enthael1 alle Stuecke die in liste1 und liste2 vorkommen
        for stueck in liste1:            # fuer jedes stueck in liste1 
            if stueck in liste2:         # wenn stueck auch in liste2 
                gleiche.append(stueck)   # dann gehoert stueck in die Liste gleiche
        return gleiche
